package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
/** <p>This PizzaPanel demonstrates Arithmetic methods. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button.</p>
    <p>The demonstrations here are:
      <ol type="A" >
        <li>Print the place value of the number int.0. Enter a number, negative or positive, and its place value will be printed. Set boolean.1 to 'true' to add 
        the appropriate suffix: '-s' if int.0 is positive, '-ths' if it is negative. The place value printed corresponds to the power of ten represented by 
        the number entered. (The plural parameter is not listed here; if false the suffixes would be nothing or '-th' respectively.)</li>
        <li>Translate the number long.0 into words. Enter a long and it will be printed as the number would be spoken or spelled out.</li>
        <li>Translate <b>String</b>.0 into words. This method allows fractional (decimal) parts.</li>
        <li>Create a number from the template format in String.0. The template format is per {@link cox.jmatt.java.MathTools.Arithmetic#createNumber Arithmetic.createNumber().} </li>
        <li>Turn int.0 into a digit array. The values are printed individually. The element index in the array equals the digit's place value as a power of 10, so 
        the number itself is printed 'backwards.'</li>
        <li>Turn int.0 into a digit array, then call Arithmetic.fromDigitArray() to turn it back. The number is printed exactly as entered, but the actual demo 
        <i>does</i> convert it to a digit array and then back!</li>
        <li>Generate a person. Arithmetic has a list of a few names for use in randomizing word problems. The name is returned as element 0 in an array that also 
        contains pronouns of the proper gender, capitalized and plain.</li>
        <li>Round and truncate the floating-point number double.0. The number of places to fix and round is specified in int.1 and grouping is boolean.2. The 
        properly rounded, truncated and possibly grouped value is printed.</li>
        <li>Find the Greatest Common Factor (GCF) and Least Common Multiple (LCM) of the numbers int.0 and int.1. Both GCF and LCM are printed.</li>
        <li>Enter a space-separated group of ints in String.0. This will be parsed into a decimal array. The first number, element 0, is interpreted as the whole 
        part. Elements 1 and up are interpreted as the <i>negative</i> place value of that digit. So element 1 is '-1, tenths,' element 2 is '-2, hundredths,' etc. 
        NOTE: this is backward from a digit array!</li>
        <li>Enter a space-separated group of ints into String.0. This is splint()-ed into individual values and printed, then converted back from a decimal array. 
        Boolean.1 determines whether or not to interpret it as a digit array, boolean.2 determines whether or not it is a decimal array. If the two conflict, the 
        'digit array' flag takes precedence. If neither is true the numbers are simply split and converted, as-is.</li>
        <li>Splint String.0 into either a decimal array or digit array (boolean.2) then round it to the place specified in i.1. The result is converted back and 
        printed.</li>
        <li>From the range Int.1 &lt;= N &lt; Int.2, find a number indivisible by Int.0 and a number relatively prime to Int.0.</li>
      </ol></p>
*/
public class ArithmeticPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("Arithmetic Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);
    
    myPicker.add("A. getPlaceValue(i.0, b.1) i.0 is the place value, b.1 true adds the suffix");
    myPicker.add("B. Translate L.0 into words.");
    myPicker.add("C. Translate STRING.0 into words. (Decimals allowed!)");
    myPicker.add("D. createNumber(s.0).");
    myPicker.add("E. toDigitArray(i.0). Elements are printed individually.");
    myPicker.add("F. fromDigitArray(toDigitArray(i.0)).");
    myPicker.add("G. Information on a random person: getPerson().");
    myPicker.add("H. Call fix(d.0, i.1, b.2)");
    myPicker.add("I. Find the GCF and LCM of i.0 and i.1 (call gcf(i.0, i.1)).");
    myPicker.add("J. Turn s.0 into a decimal array.");
    myPicker.add("K. Call splint(s.0, b.1, b.2) and dump it, then fromDecimalArray().");
    myPicker.add("L. Call splint(s.0, ~b.2, b.2), call round([], i.1, b.2), and print it.");
    myPicker.add("M. For i.2, find an indivisible and a coprime from [i.0, i.1).");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    eatPizza();
    int iLow = 0, iHigh = 0;
    double dTemp = 0.0;
    boolean bTemp = false;
    int[] decArr = {0};
    StringBuffer sbTemp = new StringBuffer();
    switch(sChoice.charAt(0)) {
      case 'A':
        CapCom.println("Place value: "+Arithmetic.getPlaceValue(asInt(0), asBoolean(1)));
        break;
      case 'B':
        CapCom.println(Arithmetic.toWords(asLong(0)));
        break;
      case 'C':
        CapCom.println(Arithmetic.toWords(asString(0)));
        break;
      case 'D':
        CapCom.println(Arithmetic.createNumber(asString(0)));
        break;
      case 'E':
        int[] iaTemp = Arithmetic.toDigitArray(asInt(0));
        for(int i=0; i < iaTemp.length; i++) {
          CapCom.println("["+i+"] = "+iaTemp[i]);
        }
        break;
      case 'F':
        CapCom.println("To int[] and back: "+Arithmetic.fromDigitArray(Arithmetic.toDigitArray(asInt(0))));
        break;
      case 'G':
        String[] sTemp = Arithmetic.getPerson();
        for(int i=0; i < sTemp.length; i++) {
          CapCom.println("["+i+"]: "+sTemp[i]);
        }
        break;
      case 'H':
        CapCom.println(Arithmetic.fix(asDouble(0), asInt(1), asBoolean(2)));
        break;
      case 'I':
        CapCom.println("GCF: "+Arithmetic.gcf(asInt(0), asInt(1)));
        CapCom.println("LCM: "+Arithmetic.lcm(asInt(0), asInt(1)));
        break;
      case 'J':
        decArr = Arithmetic.toDecimalArray(asString(0));
        sbTemp = new StringBuffer();
        for(int i=0; i < decArr.length; i++) {
          sbTemp.append(decArr[i]).append(" ");
        }
        CapCom.println(sbTemp.toString());
        break;
      case 'K':
        decArr = Arithmetic.splint(asString(0), asBoolean(1), asBoolean(2));
        sbTemp = new StringBuffer();
        for(int i=0; i < decArr.length; i++) {
          sbTemp.append(decArr[i]).append(" ");
        }
        CapCom.println("To array: "+sbTemp.toString());
        CapCom.println("Back fromDecimalArray: "+Arithmetic.fromDecimalArray(decArr));
        break;
      case 'L':
        bTemp = asBoolean(2);
        iLow = asInt(1);
        decArr = Arithmetic.round(Arithmetic.splint(asString(0), !bTemp, bTemp), iLow, bTemp);
        CapCom.println("Round "+(bTemp?"decimal":"digit")+" array to "+Arithmetic.getPlaceValue(iLow, true)+": "+(bTemp?Arithmetic.fromDecimalArray(decArr):Arithmetic.fromDigitArray(decArr)));
        break;
      case 'M':
        CapCom.println("Indivisible by "+asString(2)+": "+Arithmetic.indivisible(asInt(0), asInt(1), asInt(2)));
        CapCom.println("Coprime with "+asString(2)+": "+Arithmetic.coprime(asInt(0), asInt(1), asInt(2)));
        break;
      case 'N':

        break;
      case 'O':

        break;
      case 'P':

        break;
      case 'Q':

        break;
      case 'R':

        break;
      default:
    }
  }
}

