package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
/** <p>This PizzaPanel demonstrates MEquation methods. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button.</p>
    <p>All of the demos in this panel use an Equation whose TYPE_ number is taken from int.0. If int.0 does not contain a valid int, or it is out of range, a 
    TYPE_ERROR Equation is returned. The demos are:
    <ol type="A" >
      <li>Get the preformat String from the selected Equation using String.1 as Knobs.</li>
      <li>Retrieve STANDARD format for the selected Equation with String.1 set as its relation. STANDARD format is the format used in the documentation.</li>
      <li>Ask the selected Equation how many Knobs it requires.</li>
      <li>Arithmetic.splint() String.1 into ints and check the selected Equation with those values. The solution, enclosed in parentheses, is substituted for the 
          variable and the Equation is printed in STANDARD form.</li>
      <li>Check the equation (per previous selection) using String.1 as a <i>Knobs</i> String.</li>
      <li>Create and display a Question. The selected Equation is the equation used, String.1 is the Knobs string, String.2 is the variable, String.3 is the 
      relation used, and boolean.4 determines whether or not to swap sides around the relation.</li>
      <li>A MEquation is actually created using the <code>createMEquation()</code> method. It is then printed as a String, as XML, and a Question.</li>
      <li>Get and dump the <code>tokens()</code> array from the selected Equation (int.0) using String.1 for Knobs.</li>
      <li>For the equation TYPE specified by Int.0 get and print all formats using String.1 as Knobs.</li>
      <li>For equation TYPE Int.0 create a Question using the default values for the variable and relation, STANDARD format and the <code>Arithmetic.splint()</code>'ed 
          values from String.1 for the placeholders. The Question is then printed.</li>
      <li>Display all of the raw formatting templates for Equation.TYPE Int.0 using the relation specified in String.1. The <code>setFormatEscape()</code> method 
          is called with Boolean.2 prior to printing.</li>
    </ol></p>
*/
public class MEquationPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("MEquation Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);
    
    myPicker.add("A. Call preformat(s.1) on Equation.TYPE_i.0.");
    myPicker.add("B. Call getFormat(STANDARD, s.1) on Equation.TYPE_i.0.");
    myPicker.add("C. Knobs required for Equation.TYPE_i.0.");
    myPicker.add("D. Check Equation.TYPE_i.0. with Arithmetic.splint(s.1).");
    myPicker.add("E. Check Equation.TYPE_i.0 using s.1 as Knobs.");
    myPicker.add("F. Create TYPE_i.0 question, s.1 Knobs, s.2 variable, s.3 relation, b.4 reverse.");
    myPicker.add("G. Print TYPE_i.0 MEquation(s.1 Knobs, s.2 variable, s.3 relation, b.4 reverse) several ways.");
    myPicker.add("H. Call tokens(s.1) on Equation.TYPE_i.0 and dump the array.");
    myPicker.add("I. Print all formats for Equation.TYPE_i.0 with Knobs s.1.");
    myPicker.add("J. Question-valued solveEquation() for TYPE_i.0 with placeholders Arithmetic.splint(s.1).");
    myPicker.add("K. Print all raw formats for Equation.TYPE_i.0. with relation s.1, escaped on boolean.2.");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    eatPizza();
    MEquation.Equation myEqn = MEquation.getByType(asInt(0));
    CapCom.println("Equation: "+myEqn.toString());
    String[] tokenz = {};
    int iTemp = 0;
    String sTemp = "";
    switch(sChoice.charAt(0)) {
      case 'A':
        CapCom.println(myEqn.preformat(asString(1)));
        break;
      case 'B':
        CapCom.println(myEqn.getFormat(MEquation.Equation.STANDARD, asString(1)));
        break;
      case 'C':
        CapCom.println("Requires "+myEqn.numKnobs()+" Knobs.");
        break;
      case 'D':
        CapCom.println("Check: "+MEquation.checkEquation(myEqn, Arithmetic.splint(asString(1), false, false)));
        CapCom.println("Reverse Inequality: "+myEqn.bird());
        break;
      case 'E':
        CapCom.println("Check: "+MEquation.checkEquation(myEqn, MathEngine.setKnobs(asString(1))));
        CapCom.println("Reverse Inequality: "+myEqn.bird());
        break;
      case 'F':
        CapCom.println("Standard dump");
        CapCom.println(MEquation.createQuestion(myEqn, asString(1), asString(2), asString(3), MEquation.Equation.STANDARD, asBoolean(4)).format("Prob: <1>\nAns: <2>"));
        CapCom.println("- - - - - - - - - -");
        CapCom.println("OpenOffice");
        CapCom.println(MEquation.createQuestion(myEqn, asString(1), asString(2), asString(3), MEquation.Equation.OPEN_OFFICE, asBoolean(4)).format("Prob: <1>\nAns: <2>"));
        CapCom.println("- - - - - - - - - -");
        CapCom.println("MathML");
        CapCom.println(MEquation.createQuestion(myEqn, asString(1), asString(2), asString(3), MEquation.Equation.MATHML, asBoolean(4)).format("Prob: <1>\nAns: <2>"));
        CapCom.println("- - - - - - - - - -");
        CapCom.println("LaTeX");
        CapCom.println(MEquation.createQuestion(myEqn, asString(1), asString(2), asString(3), MEquation.Equation.LATEX, asBoolean(4)).format("Prob: <1>\nAns: <2>"));
        CapCom.println("- - - - - - - - - -");
        break;
      case 'G':
        MEquation eqTemp = MEquation.createMEquation(myEqn.toString(), asString(1), asString(2), asString(3), asString(4));
        CapCom.println("Data: "+eqTemp.dataString());
        CapCom.println(eqTemp.toString());
        CapCom.println(eqTemp.toXML(null));
        CapCom.println(eqTemp.toQuestion().format("Prob: <1>\nAns: <2>"));
        break;
      case 'H':
        tokenz = myEqn.tokens(asString(1));
        CapCom.println("Dumping token array");
        for(int i=0; i < tokenz.length; i++) { CapCom.println("["+i+"]= "+tokenz[i]); }
        CapCom.println("Done");
        break;
      case 'I':
        tokenz = myEqn.tokens(asString(1));
        CapCom.println("X = "+tokenz[0]);
        tokenz[0] = "X";
        CapCom.println("Reverse inequality: "+myEqn.bird()+"\n");
        CapCom.println("Standard:\t"+Question.fillTemplate(myEqn.getFormat(MEquation.Equation.STANDARD, "="), tokenz));
        CapCom.println("OpenOffice:\t"+Question.fillTemplate(myEqn.getFormat(MEquation.Equation.OPEN_OFFICE, "="), tokenz));
        CapCom.println("MathML:\t\t"+Question.fillTemplate(myEqn.getFormat(MEquation.Equation.MATHML, "="), tokenz));
        CapCom.println("LaTeX:\t\t"+Question.fillTemplate(myEqn.getFormat(MEquation.Equation.LATEX, "="), tokenz));
        
        break;
      case 'J':
        CapCom.println(MEquation.solveEquation(asInt(0), -1, null, null, Arithmetic.splint(asString(1), false, false)).format("Prob:\t<1>\nAns:\t<2>"));
        break;
      case 'K':
        iTemp = asInt(0);
        sTemp = asString(1);
        MEquation.setEscapeFormat(asBoolean(2));
        CapCom.println("Printing raw formats.");
        CapCom.println("Standard:\t"+MEquation.getFormat(iTemp, MEquation.STANDARD, sTemp));
        CapCom.println("OpenOffice:\t"+MEquation.getFormat(iTemp, MEquation.OPEN_OFFICE, sTemp));
        CapCom.println("MathML:\t\t"+MEquation.getFormat(iTemp, MEquation.MATHML, sTemp));
        CapCom.println("LaTeX:\t\t"+MEquation.getFormat(iTemp, MEquation.LATEX, sTemp));
        break;
      case 'L':

        break;
      case 'M':

        break;
      
      default:
    }
  }
}
