package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
/** <p>This PizzaPanel demonstrates MFractions. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button.</p>
    <p>The format used for entering MFractions is the standard {@link cox.jmatt.java.MathTools.MFraction#createMFraction createMFraction()} format. The demos 
      here are:
      <ol type="A" >
        <li>Create a MFraction around String.0 and call all the information methods on it.</li>
        <li>Create MFractions on String.0 and String.1 and call the two comparison methods on them.</li>
        <li>Create MFractions around String.0 and String.1 and perform arithmetic on them: add, subtract, multiply, and divide.</li>
        <li>Raise (multiply numerator and denominator by the same thing) MFraction(String.0) by int.1.</li>
        <li>Reduce (divide numerator and denominator by the same thing) MFraction(String.0) by int.1.</li>
        <li>Reduce MFraction(String.0) completely. That is, by the GCF of the numerator and denominator.</li>
        <li>Display MFraction(String.0) in the format specified by String.1, then STANDARD, STANDARD_MIXED, and toXML() with String.2 as the optional 'id=' 
        attribute. Here is the list of {@link cox.jmatt.java.MathTools.MFraction#formatMFraction format tokens}.</li>
        <li>FORMAT_DEBUG is for development, not really for production use.</li>
        <li>Create an irreducible fraction with whole part Int.0, numerator from Int.1 to Int.2 and denominator Int.3. Formatted typewriter style.</li>
      </ol></p>
*/
public class MFractionPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("MFraction Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);
    
    myPicker.add("A. Lots of information on new MFraction(i.0, i.1, i.2)");
    myPicker.add("B. MFraction(s.0).compareTo(MFraction(s.1))");
    myPicker.add("C. Arithmetic on MFraction(s.0) and MFraction(s.1).");
    myPicker.add("D. Raise MFraction(s.0) by i.1.");
    myPicker.add("E. Reduce MFraction(s.0) by i.1.");
    myPicker.add("F. Reduce MFraction(s.0) by completely.");
    myPicker.add("G. Format MFraction(s.0) per (s.1) and several defaults.");
    myPicker.add("H. Debug format MFraction(s.0).");
    myPicker.add("I. Create irreducible: i.0 whole, [i.1, i.2) numerator, i.3 denominator.");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    eatPizza();
    MFraction mfLeft = MFraction.createMFraction(asString(0)), mfRight = MFraction.createMFraction(asString(1));
    switch(sChoice.charAt(0)) {
      case 'A':
        try {
          mfLeft = new MFraction(asInt(0), asInt(1), asInt(2));
          CapCom.println("String:\t\t"+mfLeft.toString());
          CapCom.println("+ numerator():\t"+mfLeft.numerator());
          CapCom.println("+ denominator():\t"+mfLeft.denominator());
          CapCom.println("+ signum():\t"+mfLeft.signum());
          CapCom.println("+ wholePart():\t"+mfLeft.wholePart());
          CapCom.println("+ mixedNumer:\t"+mfLeft.mixedNumerator());
          CapCom.println("+ absNumer:\t"+mfLeft.absNumerator());
          CapCom.println("Proper?\t\t"+mfLeft.isProper());
          CapCom.println("Unit?\t\t"+mfLeft.isUnit());
          CapCom.println("Whole?\t\t"+mfLeft.isWhole());
          CapCom.println("Improper?\t"+mfLeft.isImproper());
          CapCom.println("Reciprocal:\t"+mfLeft.reciprocal().toString());
        } catch(Exception ex) { CapCom.error("Oops! Error.", ex); }
        break;
      case 'B':
        CapCom.println(mfLeft.toString()+".compareTo("+mfRight.toString()+") = "+mfLeft.compareTo(mfRight));
        CapCom.println(mfLeft.toString()+".sCompareTo("+mfRight.toString()+") = "+mfLeft.sCompareTo(mfRight));
        CapCom.println("Equals? "+mfLeft.equals(mfRight));
        break;
      case 'C':
        CapCom.println("Sum: "+mfLeft.add(mfRight).toString());
        CapCom.println("Difference: "+mfLeft.subtract(mfRight).toString());
        CapCom.println("Product: "+mfLeft.multiply(mfRight).toString());
        CapCom.println("Quotient: "+mfLeft.divide(mfRight).toString());
        break;
      case 'D':
        CapCom.println("Raised: "+mfLeft.raise(asInt(1)).toString());
        break;
      case 'E':
        CapCom.println("Reduced: "+mfLeft.reduce(asInt(1)).toString());
        break;
      case 'F':
        CapCom.println("Reduced completely: "+mfLeft.reduce().toString());
        break;
      case 'G':
        CapCom.println("per s.1: "+mfLeft.format(asString(1)));
        CapCom.println("per STANDARD: "+mfLeft.format(MFraction.FORMAT_STANDARD));
        CapCom.println("per STANDARD_MIXED: "+mfLeft.format(MFraction.FORMAT_STANDARD_MIXED));
        CapCom.println("per TYPICAL: "+mfLeft.format(MFraction.FORMAT_TYPICAL));
        CapCom.println("toXML(s.2): "+mfLeft.toXML(asString(2)));
        break;
      case 'H':
        CapCom.println("Format DEBUG\n"+mfLeft.format(MFraction.FORMAT_DEBUG));
        break;
      case 'I':
        CapCom.println("Irreducible: "+MFraction.createIrreducible(asInt(0), asInt(1), asInt(2), asInt(3)).format("<0>/<1>"));
        break;
      case 'J':

        break;
      case 'K':

        break;
      
      default:
    }
  }
}
