package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
/** <p>This PizzaPanel demonstrates MRadical methods. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button. all the demos use the MRadical created with Int.0 as the radicand and Int.1 as the index. The demos here are:
    <ol type="A">
      <li>Print the MRadical using:<code>toString(), toDouble(), toXML(),</code> and <code>toMathML()</code>.</li>
      <li>Print the radicand, absolute value of the radicand, index, and <code>signum()</code> of MRadical(Int.0, Int.1).</li>
      <li>Compare MRadical(Int.0, Int.1) to MRadical(Int.2, Int.3) using <code>equals(), compareTo(),</code> and <code>identicalTo()</code>.</li>
      <li>Print the MRadical using DEBUG format.</li>
      <li>Print <code>MRadical.(Int.0, Int.1).format(String.2)</code>.</li>
      <li>Debug format using the three-int factory method that also specifies a 'coefficient'.</li>
    </ol></p>
*/
public class MRadicalPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("MRadical Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);

    myPicker.add("A. Create MRadical(i.0, i.1) and print it several ways.");
    myPicker.add("B. Info about MRadical(i.0, i.1).");
    myPicker.add("C. Comparing MRadical(i.0, i.1) to MRadical(i.2, i.3).");
    myPicker.add("D. Debug format(MRadical(i.0, i.1)).");
    myPicker.add("E. Print MRadical(i.0, i.1).format(s.2).");
    myPicker.add("F. Debug format MRadical(i.0, i.1, i.2).");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    eatPizza();
    MRadical mrTemp = new MRadical(asInt(0), asInt(1));
    switch(sChoice.charAt(0)) {
      case 'A':
        CapCom.println(mrTemp.toString());
        CapCom.println("As double:\t"+mrTemp.toDouble());
        CapCom.println("As XML:\t\t"+mrTemp.toXML(null));
        CapCom.println("As MathML:\t"+mrTemp.toMathML());
        CapCom.println("As LaTeX:\t"+mrTemp.format(MRadical.FORMAT_LATEX));
        break;
      case 'B':
        CapCom.println("Radicand: "+mrTemp.radicand()+"\n|Radicand| = "+mrTemp.absRadicand()+"\nIndex: "+mrTemp.index()+"\nSign: "+mrTemp.signum());
        break;
      case 'C':
        MRadical mrSecond = new MRadical(asInt(2), asInt(3));
        CapCom.println("Equals: "+mrTemp.equals(mrSecond));
        CapCom.println("Compare: "+mrTemp.compareTo(mrSecond));
        CapCom.println("(String) "+mrTemp.sCompareTo(mrSecond));
        CapCom.println("Identical: "+mrTemp.identicalTo(mrSecond));
        break;
      case 'D':
        CapCom.println(mrTemp.format(MRadical.FORMAT_DEBUG));
        break;
      case 'E':
        CapCom.println(mrTemp.format(asString(2)));
        break;
      case 'F':
        mrTemp = MRadical.createMRadical(asInt(0), asInt(1), asInt(2));
        CapCom.println(mrTemp.format(MRadical.FORMAT_DEBUG));
        break;
      case 'G':

        break;
      case 'H':

        break;
      case 'I':

        break;

      default:
    }
  }
}

