package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
/** <p>This PizzaPanel demonstrates MathSet methods. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button.</p>
    <p>The demonstrations in this panel are:
      <ol type="A" >
        <li>Create a <code>MSet</code> using String.0 as the initial parameter then <code>addSets(String.1)</code>. The set is closed and <code>dumpInfo()</code> called.</li>
        <li>Create a set per 'A' but this time the information is via <code>toPizza()</code>/</li>
        <li>Using the pre-defined Real-Number <code>MathSet</code>, select the set described in String.0 and format it per the template in String.1. Set Boolean.2
            to true to use the Complex numbers instead.</li>
        <li>Using the Real (or Complex, if boolean.1 is true) numbers, check to see if the set in String.0 is contained.</li>
        <li>This utility demo parses the RAW data from the parameter panel into a <code>MathSet</code>. Each line should contain only valid set descriptors and 
            the area MUST be cleared completely first: no 'par.0' etc. or it will not parse properly! Once the set is parsed and stored, the pizza is sent to the 
            clipboard and printed.</li>
        <li>This utility demo parses and stores a set, but this time from a (properly-formatted!!) Pizza, preferably the result of a <code>toPizza()</code> call. 
            as above, the pizza is consumed, converted into a <code>MathSet</code> and stored using the SHELF_KEY.</li>
        <li>Using the built-in set of Complex Numbers, String.0 is selected. Next String.1 is checked with <code>hasSuperset()</code> and <code>hasSubset()</code></li>
        <li>Select String.0 from the Complex Numbers then print a random superset and subset.</li>
        <li>From the Complex Numbers select String.0. List all upersets and subsets of it.</li>
        <li>Using the Complex numbers, create and print a Question. String.0 and String.1 are the sets to select in the main and clone, respectively. String.2 is 
            the Problem format and String.3 is the Anser format. String.4 is the format used to print the Question. If not defined, the default debug format is 
            used.</li>
        <li>This demo uses the two-argument 'hasSubset' and 'hasSuperset' methods and tests the proper working of the inner clone. The set used is the Complex 
            Numbers.</li>
        <li>Create a random Question on the Complex Numbers. Boolean.0 determines whether it is a 'superset' or 'subset' question. The format symbol is changed 
            in order to fit the question (capitalized, plural).</li>
        <li>Create a simple question on the Complex numbers. String.0 and String.1 select the sets to use and boolean.2 decides superset/subset.</li>
        <li>Select String.1 in the Complex numbers, then call <code>shakeShakeShake(b.1)</code> to mix up the sets. Next call the two-string <code>createQuestion()</code> 
            with a simple format.</li>
    </ol></p>
*/
public class MathSetPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("MathSet Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);
    
    myPicker.add("A. Create a MSet around s.0 and add s.1 to it. Print the info about it.");
    myPicker.add("B. Create a MSet around s.0 and add s.1 to it. Print 'toPizza()'.");
    myPicker.add("C. Using the Reals, select(s.0) and format per s.1. B.2 true for Complex.");
    myPicker.add("D. Check if the Reals contain s.0. B.1 true for Complex.");
    myPicker.add("E. Parse a set from the (raw) param area and store on The Shelf.");
    myPicker.add("F. Create a MathSet from its 'toPizza()' method and store on The Shelf.");
    myPicker.add("G. Select s.0 from the Complex numbers and check s.1 as a superset/subset.");
    myPicker.add("H. Select s.0 from the Complex numbers and pick a random set and subset.");
    myPicker.add("I. Select s.0 from the Complex numbers and list ALL supersets and subsets.");
    myPicker.add("J. ComplexNumbers.createQuestion(s.0, s.1, s.2, s.3).format(s.4).");
    myPicker.add("K. Complex.hasSuperset(s.0, s.1) and also subset. No selecting used.");
    myPicker.add("L. Create a random question on the Complex Numbers. B.0 toggles type.");
    myPicker.add("M. Complex.createSimpleQuestion(s.0, s.1, b.2) with simple format.");
    myPicker.add("N. Complex.select(s.0), shakeShakeShake(b.1) and createQuestion()");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    eatPizza();
    MathSet setA = MathSet.createInstance(asString(0));
    setA.setName("Demo Set");
    setA.setDescription("A simple set constructed from two simple Strings.");
    String sTemp = "", sTemp2 = "";
    String[] saTemp = null;
    CapCom.println("--------------------");
    switch(sChoice.charAt(0)) {
      case 'A':
        setA.addSets(asString(1));
        setA.closeSet();
        CapCom.println(setA.dumpInfo());
        break;
      case 'B':
        setA.addSets(asString(1));
        setA.closeSet();
        CapCom.println(setA.toPizza());
        break;
      case 'C':
        if(asBoolean(2)) {
          setA = MathSet.complexNumbers();
        } else {
          setA = MathSet.realNumbers();
        }
        CapCom.println(setA.format(asString(0), asString(1)));
        CapCom.println("- - - - - - - - - -\n"+setA.toPizza());
        break;
      case 'D':
        if(asBoolean(1)) {
          setA = MathSet.complexNumbers();
        } else {
          setA = MathSet.realNumbers();
        }
        CapCom.println("("+setA.getName()+").contains("+asString(0)+"): "+setA.contains(asString(0)));
        break;
      case 'E':
        CapCom.println("Attempting to parse parameter area.");
        setA = parseMathSet();
        if(setA != null) CapCom.storeObject(MathSet.SHELF_KEY, setA);
        CapCom.println("MathSet stored: "+( (CapCom.getObject(MathSet.SHELF_KEY) != null) && (CapCom.getObject(MathSet.SHELF_KEY) instanceof MathSet) ) );
        CapCom.println(CapCom.processMathObject(setA.toPizza()).toString());
        CapCom.println("\n- - - - Pizza sent to clipboard. - - - -");
        break;
      case 'F':
        setA = MathSet.createFromPizza(getRawPizza(), false, false);
        if(setA != null) CapCom.storeObject(MathSet.SHELF_KEY, setA);
        CapCom.println("MathSet stored: "+( (CapCom.getObject(MathSet.SHELF_KEY) != null) && (CapCom.getObject(MathSet.SHELF_KEY) instanceof MathSet) ) );
        CapCom.println(CapCom.processMathObject(setA.toPizza()).toString());
        CapCom.println("\n- - - - Pizza sent to clipboard. - - - -");
        break;
      case 'G':
        setA = MathSet.complexNumbers();
        setA.select(asString(0));
        sTemp = asString(0); sTemp2 = asString(1);
        CapCom.println(sTemp+".hasSuperset( "+sTemp2+" ): "+setA.hasSuperset(sTemp2));
        CapCom.println(sTemp+".hasSubset( "+sTemp2+" ): "+setA.hasSubset(sTemp2));
        break;
      case 'H':
        setA = MathSet.complexNumbers();
        setA.select(asString(0));
        CapCom.println("Selected: "+setA.getSelectedSet());
        CapCom.println("Subset: "+setA.randomSubset());
        CapCom.println("Superset: "+setA.randomSuperset());
        break;
      case 'I':
        setA = MathSet.complexNumbers();
        setA.select(asString(0));
        saTemp = setA.getSupersets();
        CapCom.println("Superset chain String: "+setA.getSupersetString());
        CapCom.println("Listing supersets.");
        for(int i=0; i < saTemp.length; i++) CapCom.println("["+i+"]: "+saTemp[i]);
        saTemp = setA.getSubsets();
        CapCom.println("Listing subsets.");
        for(int i=0; i < saTemp.length; i++) CapCom.println("["+i+"]: "+saTemp[i]);
        break;
      case 'J':
        setA = MathSet.complexNumbers();
        sTemp = asString(4);
        sTemp = Question.validString(sTemp)?sTemp:MathSet.DEBUG_QUESTION_FORMAT;
        CapCom.println(setA.createQuestion(asString(0), asString(1), asString(2), asString(3)).format(sTemp));
        break;
      case 'K':
        setA = MathSet.complexNumbers();
        CapCom.println("hasSuperset(s.0, s.1): "+setA.hasSuperset(asString(0), asString(1)));
        CapCom.println("hasSubset(s.0, s.1): "+setA.hasSubset(asString(0), asString(1)));
        break;
      case 'L':
        setA.setDefaultFormat("<1>");
        setA = MathSet.complexNumbers();
        CapCom.println(setA.createRandomQuestion(asBoolean(0)).format("Q: <1>\nA: <2>"));
        break;
      case 'M':
        setA.setDefaultFormat("<1>");
        setA = MathSet.complexNumbers();
        CapCom.println(setA.createSimpleQuestion(asString(0), asString(1), asBoolean(2)).format("Q: <1>\nA: <2>"));
        break;
      case 'N':
        setA = MathSet.complexNumbers();
        setA.select(asString(0));
        setA.shakeShakeShake(asBoolean(1));
        CapCom.println(setA.createQuestion("<0> ?? <1>", "<20> of, <22> of.").format("Q: <1>\nA: <2>"));
        break;
      case 'O':

        break;
      case 'P':

        break;
      case 'Q':

        break;
      case 'R':

        break;
      case 'S':

        break;
      default:
    }
  }
  /** This method is used to parse the (RAW!) contents of the parameter area into a MathSet. Demo selection 'E' uses this method to build a <code>MathSet</code> 
      and store it on The Shelf. If the area is empty, <code>MathSet.emptySet()</code> is returned.
  */
  public MathSet parseMathSet() {
    String rawData = getRawPizza();
    if(!Question.validString(rawData)) return MathSet.emptySet();
    String[] sLines = rawData.split("\n");
    MathSet retval = MathSet.createInstance(sLines[0]);
    for(int i=1; i < sLines.length; i++) retval.addSets(sLines[i]);
    retval.closeSet();
    return retval;
  }

}

