package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
/** <p>This PizzaPanel demonstrates Percent methods. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button.</p>
    <p>All demos assume the Base as double.0, the Rate as double.1 and the Amount as double.2. The definitions of these terms are 
    {@link cox.jmatt.java.MathTools.Percent here}. Demos 'A' through 'D' are self-explanatory. Demos 'E' and 'F', the format() demos, require only a little more 
    detail.
    <ul>
      <li>Double.0, double.1 and double.2 are the Base, Rate and Amount but ONE of them must be blank. This is the one solved for in the method.</li>
      <li>String.3 is the {@link cox.jmatt.java.MathTools.Percent#format format} string used for the Problem and Answer parts of the Question.</li>
      <li>Int.4, int.5 and int.6 are the number of decimal places to fix in the Base, Rate, and Amount respectively.</li>
    </ul>
    If all of Base, Rate and Amount are specified, Amount is ignored and calculated.</p>
    <p>Demo 'F', the Percent Change demo, operates identically to 'E' save that Double.0 and Double.1 are the start and end values, String.2 is the template, 
    Int.3 to Int.5 are the fix values and Boolean.6 determines grouping.</p>
    <p>Demo 'G' converts between percent and decimal; Double.0 is the percent, Double.1 is the decimal and int.1 is the number of places to fix in the result. 
    One of D.0 and D.1 should be null. If int.2 is null no fix is done.</p>
*/
public class PercentPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("Percent Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);
    
    myPicker.add("A. ALL DEMOS!!! Base = d.0, Rate = d.1, Amount = d.2!!!");
    myPicker.add("B. Solve for Base: solveBase(d.1, d.2).");
    myPicker.add("C. Solve for Rate: solveRate(d.0, d.2).");
    myPicker.add("D. Solve for Amount: solveAmount(d.0, d.1).");
    myPicker.add("E. formatQuestion(d.0, d.1, d.2, s.3, i.4, i.5, i.6, b.7).");
    myPicker.add("F. formatChange(d.0, d.1, s.2, i.3, i.4, i.5, b.6).");
    myPicker.add("G. convertRate(D.0, D.1, i.2).");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    eatPizza();
    Double dBase = Question.validString(asString(0))?asDouble(0):null;
    Double dRate = Question.validString(asString(1))?asDouble(1):null;
    Double dAmount = Question.validString(asString(2))?asDouble(2):null;
    Question qTemp = null;
    
    switch(sChoice.charAt(0)) {
      case 'A':
        CapCom.println("Base: "+asDouble(0)+"\nRate: "+asDouble(1)+"\nAmount: "+asDouble(2)+"\nAlways!!!");
        break;
      case 'B':
        CapCom.println("Base = "+Percent.solveBase(asDouble(1), asDouble(2)));
        break;
      case 'C':
        CapCom.println("Rate = "+Percent.solveRate(asDouble(0), asDouble(2)));
        break;
      case 'D':
        CapCom.println("Amount = "+Percent.solveAmount(asDouble(0), asDouble(1)));
        break;
      case 'E':
        qTemp = Percent.format(dBase, dRate, dAmount, asString(3), asInt(4), asInt(5), asInt(6), asBoolean(7));
        CapCom.println(qTemp.format(Question.FORMAT_DEBUG));
        break;
      case 'F':
        qTemp = Percent.formatChange(asDouble(0), asDouble(1), asString(2), asInt(3), asInt(4), asInt(5), asBoolean(6));
        CapCom.println(qTemp.format(Question.FORMAT_DEBUG));
        break;
      case 'G':
        CapCom.println("Converted:\t"+Percent.convertRate(dBase, dRate, (dAmount == null)?-1:asInt(2)));
        break;
      case 'H':

        break;
      case 'I':

        break;
      
      default:
    }
  }
}
