package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
import cox.jmatt.java.MathTools.test.*;

/** <p>This PizzaPanel demonstrates Question and MTest methods. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button.</p>
    <p>The Question and MTest demos are:
      <ol type="A" >
        <li>Create a new Question with String.0 for an ID, String.1 as the Problem and String.2 as the Answer. The Question is then printed using its toString() 
        method and again using FORMAT_DEBUG. FORMAT_DEBUG is <b>not</b> an 'official' presentation format! It is intended to examine ALL aspects of the Question 
        with an eye for correcting erros.</li>
        <li>Use String.0 as a {@link cox.jmatt.java.MathTools.Question#fillTemplate template}. It is then filled with String.1 split on spaces and fed to 
        Question.fillTemplate() and the result printed.</li>
        <li>Create a new Question per demo 'A' and print it using the standard formats: STANDARD, PROPERTIES, VELOCITY, and the Clicker version of each. The Clicker
        is set to 10 before printing the _CLICK formats and the Question is click()'d each time.</li>
        <li>Create a Question per 'A' and print it as XML. Boolean.3 true causes each part to be {@link cox.jmatt.java.MathTools.MathXML#escapeXML escaped} 
        before printing.</li>
        <li>Call <code>numberToLetter()</code> on int.0 and print the result.</li>
        <li>Call <code>formatVCode()</code> using String.0 as the formatting template.</li>
        <li>Create an MTest with a few items added automatically, then print it.</li>
        <li>Create an MTest with a few items and print it as XML.</li>
        <li>Demonstrate MathTestFormatter on a VERY simple template. Use boolean.0 to toggle between printing the template and filling it.</li>
        <li>This selection clears the parameter area and fills it with sample data for a <code>MTestParser</code>. It does NOT actually parse it.</li>
        <li>Create a <code>MTestParser</code> and parse the content of the parameter area. The resulting <code>MTest</code> is printed and sent to the clipboard.</li>
      </ol></p>
*/
public class QuestionPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("Question/MTest Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);
    
    myPicker.add("A. new Question(s.0, s.1, s.2).toString() and FORMAT_DEBUG.");
    myPicker.add("B. Question.fillTemplate(s.0, s.1[]), s.1[] is s.1 split on spaces.");
    myPicker.add("C. createQuestion(s.0, s.1, s.2) printed in standard formats.");
    myPicker.add("D. new Question(s.0, s.1, s.2).toXML(b.3)");
    myPicker.add("E. Convert i.0 to letter(s).");
    myPicker.add("F. Format a version code per s.0.");
    myPicker.add("G. Create an MTest, add a few things, then call toString().");
    myPicker.add("H. Create an MTest, add a few things, then call toXML()().");
    myPicker.add("I. MathTestFormatter.fillTemplate() with ${par.X} tokens, b.0 true to print the template.");
    myPicker.add("J. Load the parameter area with test data for MTestParser.");
    myPicker.add("K. Create a MTestParser, parse the param area and processMathObject() on the result.");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    java.util.Properties myPizza = eatPizza();
    Question qTemp = new Question(asString(0), asString(1), asString(2));
    MTest myTest = new MTest();
    myTest.setLineSeparator("\n- - - - - - - - - -\n");
    switch(sChoice.charAt(0)) {
      case 'A':
        CapCom.println(qTemp.toString());
        CapCom.println(qTemp.format(Question.FORMAT_DEBUG));
        break;
      case 'B':
        CapCom.println(Question.fillTemplate(asString(0), asString(1).split(" ")));
        break;
      case 'C':
        CapCom.println("STANDARD: "+qTemp.format(Question.DEFAULT_QUESTION_FORMAT));
        CapCom.println("PROPERTIES:\n"+qTemp.format(Question.FORMAT_PROPERTIES));
        CapCom.println("VELOCITY:\n"+qTemp.format(Question.FORMAT_VELOCITY));
        break;
      case 'D':
        qTemp.setEscapeXML(asBoolean(3));
        CapCom.println(qTemp.toXML());
        break;
      case 'E':
        CapCom.println("As letter: "+Question.numberToLetter(asInt(0)));
        break;
      case 'F':
        CapCom.println("Version code: \t"+Question.formatVCode(asString(0)));
        break;
      case 'G':
        qTemp = new Question();
        qTemp.setFormat(Question.FORMAT_PROPERTIES);
        qTemp.setClicker(0); qTemp.setIDFormat("Q <0> <1> <2>");
        myTest.addBlock("Text block meant for the Problem part only!\nPrimarily meant for title and instructions.\n");
        myTest.add(qTemp.setData(null, "Is this the first question?", "This is the first question.").click());
        myTest.addLine("This is a literal line inserted into the test Problem and Answer.\n");
        myTest.add(qTemp.setData(null, "Who's on second?", "Who's on first, What's on second.").click());
        myTest.addGraphMark("GRAPH_MARK: Insert cool graph here.");
        myTest.add(qTemp.setData(null, "I dunno?", "THIRD BASE!!").click());
        myTest.addNote("This should appear on the Answer Key after the last answer.");
        myTest.addPageBreak();
        CapCom.println(myTest.toString());
        break;
      case 'H':
        qTemp = new Question();
        qTemp.setFormat(Question.FORMAT_PROPERTIES);
        qTemp.setClicker(0); qTemp.setIDFormat("Q <0> <1> <2>");
        myTest.add(qTemp.setData(null, "Is this the first question?", "This is the first question.").click());
        myTest.addLine("This is a literal line inserted into the test.\n");
        myTest.add(qTemp.setData(null, "Who's on second?", "Who's on first, What's on second.").click());
        myTest.addBlock("This is a BLOCK.\nNot so different from a line, except in philosophy.\n");
        myTest.add(qTemp.setData(null, "I dunno?", "THIRD BASE!!").click());
        myTest.addNote("This should appear on the Answer Key after the last answer.");
        myTest.addPageBreak();
        CapCom.println(myTest.toXML());
        break;
       case 'I':
         String sTemplate = "- - Templating - -\nFavorite food:\t${par.1} with plenty of ${par.2}\nFavorite song:\t${par.3} by ${par.4}\nVersion:\t${par.5}\n" + 
         "Today is:\t@{date} at @{time}\nTimestamp:\t@{timestamp}";
         CapCom.println((asBoolean(0)?sTemplate:MathTestFormatter.fillTemplate(sTemplate, myPizza)));
        break;
      case 'J':
        clearParams();
        _addToPizza("@@ This is a comment. It doesn't appear in the output.\n@B MTestParser Sample Test\n@LI. First Test Section\n");
        _addToPizza("@I I<1>\n@F<0>. <1> @@ <0>. <2>\nIs this a question? @@ First section, first question!\nSecond question?@@Second indeed!\n@GCool Graph #1\n");
        _addToPizza("@L II. Second Test Section.\n@NSecond section of the answer key, too.\n@C 0\n");
        _addToPizza("@I II<2>\nSecond section, first question? @@ Section 2, Question 1.\n@P");
        
        CapCom.println("Test data entered. Now choose selection 'J' to parse and print it.");
        break;
      case 'K':
        myTest.setLineSeparator("\n");
        myTest = ((new MTestParser()).setMTest(myTest)).parse(getRawPizza());
        CapCom.println(CapCom.processMathObject((Object) myTest.formatTest()).toString());
        break;
      case 'L':

        break;
      case 'M':

        break;
      default:
    }
  }
}
