package cox.jmatt.java.MathTools.demo;

import java.awt.*;
import cox.jmatt.java.MathTools.*;
import cox.jmatt.java.MathTools.markup.svg.*;

/** <p>This PizzaPanel demonstrates SVG classes. The parameter types are specified on the Choice component and the indicated method is called by clicking 
    the [Go!] button. The demos here are fairly self-explanatory.</p>
*/
public class SVGPizza extends PizzaPanel {

  private Choice myPicker;

  public Panel getNorthPanel() {
    myPicker = new Choice();
    Panel pnlTemp = new Panel(new BorderLayout());
    pnlTemp.add(new Label("SVG Generator Test Pizza", Label.CENTER), BorderLayout.NORTH);
    pnlTemp.add(myPicker, BorderLayout.SOUTH);
    
    myPicker.add("A. Print a StylePen with stroke(color) s.0, fill-rule b.1, and stroke-linejoin char.2.");
    myPicker.add("B. <circle cx='s.0' cy='s.1' r='s.2' />");
    myPicker.add("C. <ellipse cx='s.0' cy='s.1' rx='s.2' ry='s.3' />");
    myPicker.add("D. <line x1='s.0' y1='s.1' x2='s.2' y2='s.3' />");
    myPicker.add("E. <rect x='s.0' y='s.1' width='s.2' height='s.3' />");
    myPicker.add("F. Rounded <rect x='s.0' y='s.1' width='s.2' height='s.3' rx='s.4' ry='s.5' />");
    myPicker.add("G. PathTag.arcTo(d.0, d.1, d.2, b.3, b.4, d.5, d.6).");
    myPicker.add("H. <poly (b.0?GON:LINE) points='splint(s.1)' />");
    
   return pnlTemp;
  }

  public void processGoButton() {
    String sChoice = myPicker.getSelectedItem()+"  ";
    eatPizza();
    switch(sChoice.charAt(0)) {
      case 'A':
        StylePen penTemp = new StylePen();
        penTemp.setStroke(asString(0));
        penTemp.setFillNonzero(asBoolean(1));
        penTemp.setStrokeLinejoin((asString(2)+" ").charAt(0));
        CapCom.println("Raw data: "+penTemp.toString());
        CapCom.println("CSS: "+penTemp.toCSS());
        CapCom.println("Att. String: "+penTemp.toAttribute());
        break;
      case 'B':
        CapCom.println(new CircleTag(asDouble(0), asDouble(1), asDouble(2)).toString());
        break;
      case 'C':
        CapCom.println(new EllipseTag(asDouble(0), asDouble(1), asDouble(2), asDouble(3)).toString());
        break;
      case 'D':
        CapCom.println(new LineTag(asDouble(0), asDouble(1), asDouble(2), asDouble(3)).toString());
        break;
      case 'E':
        CapCom.println(new RectangleTag(asDouble(0), asDouble(1), asDouble(2), asDouble(3)).toString());
        break;
      case 'F':
        CapCom.println(new RectangleTag(asDouble(0), asDouble(1), asDouble(2), asDouble(3), asDouble(4), asDouble(5)).toString());
        break;
      case 'G':
        CapCom.println(new PathTag().arcTo(asDouble(0), asDouble(1), asDouble(2), asBoolean(3), asBoolean(4), asDouble(5), asDouble(6)).toString());
        break;
      case 'H':
        PolygonTag myPoly = new PolygonTag();
        myPoly.setPolygon(asBoolean(0));
        int[] pointz = Arithmetic.splint(asString(1), false, false);
        for(int i=0; i < pointz.length / 2; i++) { myPoly.addVertex(pointz[2*i], pointz[2*i + 1]); }
        CapCom.println(myPoly.toString());
        break;
      case 'I':
        
        break;
      case 'J':
        
        break;
      case 'K':
        
        break;
      
      default:
    }
  }
}

