package cox.jmatt.java.MathTools.graphing.Graph;

import cox.jmatt.java.MathTools.graphing.*;

/** <p>The Graph implementation uses two Renderable classes and one concrete class besides this one. All graphing functionality is contained within the 
    <code>GraphablePDK</code> and <code>GraphPaperPDK</code> classes. The <code>GraphKeysPDK</code> class is used as a context object (ONLY) but this is handled 
    automatically. All key Objects in this class are ignored.</p>
    <p>Since there are several <code>Renderable</code> classes that are not used this class extends <code>graphing.noop.NOGraphEngine</code>. All <b>get__()</b> 
    methods return non-null instances and the set/test feature methods work even though only three <code>GraphEngine</code> methods are defined here.</p>
*/
public class GraphEnginePDK extends cox.jmatt.java.MathTools.graphing.noop.NOGraphEngine {

  /** Required for <code>GraphEngineFactory</code> */
  public GraphEnginePDK() { super(); }

  /** Returns a GraphKeysPDK, but shouldn't be needed. */
  public GraphKeys getGraphKeys() { return new GraphKeysPDK(); }

  /** Returns a GraphPaperPDK. The 'pKey' parameter is ignored since there is only ONE type of GraphPaperPDK. */
  public GraphPaper getGraphPaper(Object pKey) { return new GraphPaperPDK(); }

  /** Returns a <code>GraphablePDK</code> instance. The key parameter is ignored. */
  public Graphable getGraph(Object pKey) { return new GraphablePDK(); }

}
