package cox.jmatt.java.MathTools.graphing;

/** <p>This is a marker interface, it defines no methods. It is intended to mark classes used to hold static constants but it is by no means limited to this. A 
    <code>GraphKeys</code> instance can be used for any class that provides something useful or necessary to a graphing implementation.</p>
    <p>One possible use of GraphKeys is as a Rendering Context Object. If an implementation has some context requirements but they are not complicated, 
    the necessary machinery can be built into a class which in turn implements this interface. Alternately, if rendering context requirements are more complex, 
    the GraphKeys class can be used to create or provide them.</p>
*/
public interface GraphKeys {}

