package cox.jmatt.java.MathTools.graphing.xml;

import cox.jmatt.java.MathTools.graphing.*;

/** This class is NOT used as a rendering context! The <code>graphing.xml.*</code> classes don't need one. Instead it is used to hold static key constants for 
    condition-testing for <code>RenderableXML</code> and <code>GraphableXML</code> classes. It also provides a hit counter used to generate document-unique IDs 
    for the tags that require them.
*/
public class GraphKeysXML implements GraphKeys {

  /** Use this (String) as the 'condition' argument to verify that a Renderable has its name set. */
  public static final Object GOT_NAME = "RenderableXML: NAME";

  /** Use this (String) as the 'condition' argument to verify that a Renderable has its type set. */
  public static final Object GOT_TYPE = "RenderableXML: TYPE";

  /** Use this (String) as the 'condition' argument to verify that a Renderable has its ID set. */
  public static final Object GOT_ID = "RenderableXML: ID";

  /** Use this String as the condition along with a String value to test whether or not a Graphable contains the specified limit. */
  public static final String HAS_LIMIT = "GraphableXML: LIMIT";

  /** Use this String as the condition along with a String value to test whether or not a Graphable contains the specified expression. */
  public static final String HAS_EXPRESSION = "GraphableXML: EXPRESSION";

  private static long numberOfHits = 0;

  /** This method is provided to allow graphing elements to generate unique field values when none are provided. */
  public static long hitCount() { return numberOfHits++; }

}
