package cox.jmatt.java.MathTools.markup.html;

/** <p>This class represents the HTML document itself. It handles the &lt;head&gt; and &lt;body&gt; tags internally along with all DTD and namespace issues. The 
    main content handling methods deal with the body of the document, the head is handled automatically.</p>
*/
public class HTMLTag extends DivTag {

  private String myTitle = null;
  private boolean hotCopy = false;

  /** Constructor for a fresh document. */
  public HTMLTag() {
    super(BaseHTag.TagKeys.HTML_TAG);
    myLevel = BODY_LEVEL;
  }

  /** Overridden to handle internal things that must be handled. */
  protected void _setContent(String pContent) {
    if(pContent == null) {
      myTitle = null;
    }
    super._setContent(pContent);
  }

  /** Copy this <code>HTMLTag</code>. */
  public HTMLTag copyOf() {
    hotCopy = true;
    _enableCopy();
    hotCopy = false;
    HTMLTag retval = new HTMLTag();
    retval.setTitle(myTitle);
    return retval;
  }

  /** Overridden to construct the full HTML document, body and head. */
  protected String _content() {
    if(hotCopy) return super._content();
    StringBuffer retval = new StringBuffer();
    retval.append("<head>\n");
    if(validString(myTitle)) retval.append(" <title>").append(myTitle).append("</title>\n");
    retval.append("</head>\n<body>\n");
    retval.append(super._content());
    retval.append("</body>\n");
    return retval.toString();
  }

  /** Set or clear the document &lt;title&gt;. */
  public void setTitle(String pTitle) { myTitle = pTitle; }

}

