package cox.jmatt.java.MathTools.markup.html;

/** These are heading tags: &lt;h1&gt; to &lt;h6&gt;. All use the same default values so setting 'Hn_TAG' affects all heading tag classes. */
public class HnTag extends SimpleDecorationTag {

  /** Standard constructor for editable tags. */
  public HnTag() { super(BaseHTag.TagKeys.Hn_TAG); }

  /** Construct a tag with the level given. */
   public HnTag(byte pLevel) {
     super(BaseHTag.TagKeys.Hn_TAG);
     if((pLevel >=1) && (pLevel <= 6)) myTagName = "h"+pLevel;
   }

  /** Construct a tag with content. */
  public HnTag(String pContent) { super(BaseHTag.TagKeys.Hn_TAG, pContent); }

  /** Construct a tag with level and content given. */
  public HnTag(byte pLevel, String pContent) {
    super(BaseHTag.TagKeys.Hn_TAG, pContent);
    if((pLevel >=1) && (pLevel <= 6)) myTagName = "h"+pLevel;
  }

  /** Copy the current tag. */
  public HnTag copyOf() {
    _enableCopy();
    return new HnTag();
  }

  /** Change the heading level of the tag. Only the numbers '1' through '6' are valid, anything else is ignored. */
  public HnTag setLevel(byte pLevel) {
    if((pLevel >=1) && (pLevel <= 6)) myTagName = "h"+pLevel;
    return this;
  }

}

