package cox.jmatt.java.MathTools.markup.html;

/** This class provides the &lt;li&gt; tag. Since lists can contain sublists, ordered or unordered, this method also contains the <code>add(ListTag)</code> method. */
public class LITag extends SimpleDecorationTag {

  /** Standard constructor for editable tags. */
  public LITag() { super(BaseHTag.TagKeys.LI_TAG); }

  /** Construct a tag with content. */
  public LITag(String pContent) { super(BaseHTag.TagKeys.LI_TAG, pContent); }

  /** Copy the current tag. */
  public LITag copyOf() {
    _enableCopy();
    return new LITag();
  }

  /** Add a list to the current item. The <code>ListTag</code> is converted to String when added so subsequent changes to it will not appear. A self-reference 
      is returned and the tag is ignored if it is null.
  */
  public LITag addList(ListTag pList) {
    _addTag(pList);
    return this;
  }

}

