package cox.jmatt.java.MathTools.markup.svg;

import cox.jmatt.java.MathTools.markup.*;

/** <p>This class provides the SVG &lt;ellipse&gt; tag. It is similar to <code>CircleTag</code> except that it requires two radii and does not provide the 'point' 
    methods.</p>
*/
public class EllipseTag extends StyleTag {

  /** Standard constructor. No data set. */
  public EllipseTag() { super(TagKeys.ELLIPSE_TAG); }

  /** Copy this class. */
  public EllipseTag copyOf() {
    _enableCopy();
    return new EllipseTag();
  }

  /** Create a EllipseTag with all data present. */
  public EllipseTag(Double X1, Double Y1, Double XRad, Double YRad) {
    super(TagKeys.ELLIPSE_TAG);
    setData(X1, Y1, XRad, YRad);
  }

  /** Set ellipse-specific data center and radii. */
  public EllipseTag setData(Double X1, Double Y1, Double XRad, Double YRad) {
    _addNAttribute("cx", X1); _addNAttribute("cy", Y1);
    _addNAttribute("rx", XRad); _addNAttribute("ry", YRad);
    return this;
  }

}

